#ifndef SCM_GC_INTERNAL_H
#define SCM_GC_INTERNAL_H

/* Copyright 2025 Free Software Foundation, Inc.

   This file is part of Guile.

   Guile is free software: you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   Guile is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
   License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with Guile.  If not, see
   <https://www.gnu.org/licenses/>.  */



#include "libguile/scmconfig.h"
#include <gc-api.h>

SCM_INTERNAL struct gc_heap* the_gc_heap;

SCM_INTERNAL void scm_i_init_guile (struct gc_stack_addr base);
SCM_INTERNAL struct gc_mutator* scm_storage_prehistory (struct gc_stack_addr);
SCM_INTERNAL void scm_threads_prehistory (struct gc_mutator *,
                                          struct gc_stack_addr);



#endif /* SCM_GC_INTERNAL_H */
