#ifndef SCM_THREADS_INTERNAL_H
#define SCM_THREADS_INTERNAL_H

/* Copyright 2025 Free Software Foundation, Inc.

   This file is part of Guile.

   Guile is free software: you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   Guile is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
   License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with Guile.  If not, see
   <https://www.gnu.org/licenses/>.  */



#include "libguile/scm.h"
#include "gc-edge.h"



struct scm_thread;
struct scm_vm;
struct gc_heap;

SCM_INTERNAL void
scm_trace_thread_mutator_roots (struct scm_thread *thread,
                                void (*trace_edge)(struct gc_edge edge,
                                                   struct gc_heap *heap,
                                                   void *trace_data),
                                struct gc_heap *heap,
                                void *trace_data);

SCM_INTERNAL void scm_trace_thread (struct scm_thread *thread,
                                    void (*trace_edge)(struct gc_edge edge,
                                                       struct gc_heap *heap,
                                                       void *trace_data),
                                    struct gc_heap *heap,
                                    void *trace_data);

SCM_INTERNAL void scm_trace_vm (struct scm_vm *vp,
                                void (*trace_edge)(struct gc_edge edge,
                                                   struct gc_heap *heap,
                                                   void *trace_data),
                                struct gc_heap *heap,
                                void *trace_data);


#endif  /* SCM_THREADS_INTERNAL_H */
